function [xx,yy,wei] = alignworms(xxx,yyy,wei);

if iscell(xxx)
  N=length(xxx);
  K=length(xxx{1});
  xx=zeros(K,N);
  yy=zeros(K,N);
  for n=1:N
    xx(:,n) = xxx{n};
    yy(:,n) = yyy{n};
  end
else
  xx=xxx;
  yy=yyy;
  [K N]=size(xx);
end

if nargin<3
  wei=0*xx;
end

% Step 1: align them all in the same direction
for n=2:N
  if sum((xx(:,n)-flipud(xx(:,n-1))).^2+(yy(:,n)-flipud(yy(:,n-1))).^2) < ...
	sum((xx(:,n)-xx(:,n-1)).^2+(yy(:,n)-yy(:,n-1)).^2)
    xx(:,n) = flipud(xx(:,n));
    yy(:,n) = flipud(yy(:,n));
    wei(:,n) = flipud(wei(:,n));
  end
end

% Step 2: max sure head is first
df1 = sum(sum((xx(2:end,2:end) - xx(1:end-1,1:end-1)).^2 + ...
    (yy(2:end,2:end) - yy(1:end-1,1:end-1)).^2));
df2 = sum(sum((xx(1:end-1,2:end) - xx(2:end,1:end-1)).^2 + ...
    (yy(1:end-1,2:end) - yy(2:end,1:end-1)).^2));
if df2<df1
  xx=flipud(xx);
  yy=flipud(yy);
  wei=flipud(wei);
end

if nargout<3
  clear wei
end
