function [xx,yy,im] = findbydirection(imax,dirs,varargin)
% (1) Find the abs. max, and work in both dirs from there, by
% calculating directions and stepping 10 pix in that direction, then
% find local max within 10 pix from there in the normal direction.

if length(varargin)==1
  kv=varargin{1};
elseif length(varargin)==2
  kv=getopt('minlen=10 thresh=0.3 iscale=4 istep=2 irange=2',{});
  kv.minlen=varargin{1};
  kv.thresh=varargin{2};
else
  kv=getopt('minlen=10 thresh=0.3 iscale=4 istep=2 irange=2',varargin);
end  

dirdx = cos(2*dirs);
dirdy = sin(2*dirs);

for tr=1:5

  [Y_,X_]=size(imax);
  [mx,id]=max(imax(:));
  xm=div(id-1,Y_)+1;
  ym=mod(id-1,Y_)+1;
  
  thr=kv.thresh*mx;
  
  fprintf(1,'Tracing along body (1/2)...                  \r');
  [xx,yy,im,lp]=tracealong(imax,dirdx,dirdy,thr,xm,ym,kv.iscale,kv.istep,kv.irange,0);
  
  fprintf(1,'Tracing along body (2/2)...                  \r');
  [xxx,yyy,imm,lp]=tracealong(imax,dirdx,dirdy,thr,xm,ym,kv.iscale,kv.istep,kv.irange,pi);

  xx=[flipud(xxx); xx(2:end)];
  yy=[flipud(yyy); yy(2:end)];
  im=[flipud(imm); im(2:end)];
  
  fprintf(1,'Found %i points on worm.                           \n',length(xx));
  
  if length(xx)<kv.minlen
    fprintf(1,'FINDBYDIRECTION: Probably not a worm at (%i,%i)...    \n',...
	round(mean(xx)),round(mean(yy)));
    for n=1:length(xx)
      x_=round(xx(n))+[-2:2];
      y_=round(yy(n))+[-2:2];
      x_=x_(x_>=1 & x_<=X_);
      y_=y_(y_>=1 & y_<=Y_);
      imax(y_,x_)=0;
    end
  else
    break;
  end
end
